diff --git a/which-pkg-broke b/which-pkg-broke
index 4f53139..59601fb 100755
--- a/which-pkg-broke
+++ b/which-pkg-broke
@@ -9,9 +9,9 @@ import time
 from string import *
 from stat import *
 
-def pkgdeps(pkg):
+def pkgdeps(pkgs):
     apt_cache = subprocess.Popen(
-        ['apt-cache', 'depends', pkg],
+        ['apt-cache', 'depends', *pkgs],
         stdout=subprocess.PIPE, stderr=subprocess.STDOUT,
         universal_newlines=True,
         env={} # force POSIX locale
@@ -27,21 +27,14 @@ def pkgdeps(pkg):
     apt_cache.wait()
     return deps
 
-def alldeps(pkg, ignore):
-    deps = {}
-    imm_deps = pkgdeps(pkg)
-    for i in imm_deps:
-        if ignore.get(i) is None:
-            deps[i] = 1
-            ignore[i] = 1
-            childeps = alldeps(i, ignore)
-            for c in childeps:
-                deps[c] = 1
-                ignore[i] = 1
-
-    dlist = list(deps.keys())
-    return dlist
-
+def alldeps(pkg):
+    seen = set()
+    todo = set([pkg])
+    while todo:
+        new = pkgdeps(todo)
+        seen |= todo
+        todo = set(new) - seen
+    return seen
 
 def localarchitectures():
     architectures = []
@@ -88,8 +81,7 @@ def pkginstalltime(pkg, architectures):
     return times
 
 def what_broke(pname):
-    pkgs = [ pname ]
-    pkgs.extend(alldeps(sys.argv[1], {}))
+    pkgs = alldeps(pname)
 
     architectures = localarchitectures()
 
